<?php /*** Funzione Thumbnail Attiva ***/

add_theme_support('post-thumbnails');

if ( function_exists('add_theme_support') ) {
	add_theme_support('post-thumbnails');
}
if ( function_exists( 'add_image_size' ) ) { 
	add_image_size( 'index-thumb', 600, 999 ); 	//(cropped) 
	add_image_size( 'slider-img-front', 330, 280, true ); //(cropped)
	add_image_size( 'slider-img-back', 280, 230, true ); //(cropped)		
}
/*
the_post_thumbnail('thumbnail');       // Thumbnail (default 150px x 150px max)
the_post_thumbnail('medium');          // Medium resolution (default 300px x 300px max)
the_post_thumbnail('large');           // Large resolution (default 640px x 640px max)
*/

?>
<?php /*** Cool Carousel: Metabox Image (Immagine in secondo piano) ***/

add_action('admin_menu', 'addMetaBox');
add_action('save_post', 'saveMetaData', 10, 2);
add_action('admin_head', 'embedUploaderCode');
 
//Define the metabox attributes.
$metaBox = array(
  'id'     => 'my-meta-box',
  'title'    => 'Immagine in secondo piano',
  'page'     => 'post',
  'context'  => 'normal',
  'priority'   => 'low',
  'fields' => array(
    array(
      'name'   => 'My Custom Image',
      'desc'   => 'Immagine che viene visualizzata nello slider in secondo piano.',
      'id'  => 'myCustomImage',  //value is stored with this as key.
      'class' => 'image_upload_field',
      'type'   => 'media'
    )
  )
);
 
function addMetaBox() {
  global $metaBox;
  add_meta_box($metaBox['id'], $metaBox['title'], 'createMetaBox', 
    $metaBox['page'], $metaBox['context'], $metaBox['priority']);
 
}
 
/**
* Create Metabox HTML.
*/
function createMetaBox($post) {
  global $metaBox;
  if (function_exists('wp_nonce_field')) {
    wp_nonce_field('awd_nonce_action','awd_nonce_field');
  }
 
  foreach ($metaBox['fields'] as $field) {
    echo '<div class="awdMetaBox">';
    //get attachment id if it exists.
    $meta = get_post_meta($post->ID, $field['id'], true);
    switch ($field['type']) {
      case 'media':
?>
        <p><?php echo $field['desc']; ?></p>
        <div class="awdMetaImage">
<?php 
        if ($meta) {
          echo wp_get_attachment_image( $meta, 'medium', true);
          $attachUrl = wp_get_attachment_url($meta);
          echo 
          '<p>URL: <a target="_blank" href="'.$attachUrl.'">'.$attachUrl.'</a></p>';
        }
?>    
        </div><!-- end .awdMetaImage -->
        <p>
          <input type="hidden" 
            class="metaValueField" 
            id="<?php echo $field['id']; ?>" 
            name="<?php echo $field['id']; ?>"
            value="<?php echo $meta; ?>" 
          /> 
          <input class="image_upload_button"  type="button" value="Scegli immagine" /> 
          <input class="removeImageBtn" type="button" value="Rimuovi immagine" />
        </p>
        <small style="padding:5px;">Per richimare il campo nel tema utilizza: <code>global $metaBox; foreach ($metaBox['fields'] as $field) { $meta = get_post_meta($post->ID, $field['id'], true);
        echo wp_get_attachment_image( $meta, 'slider-img-back', true, array('class'	=> 'img-back'));} </code> 
        </small>
 
<?php
      break;
    }
    echo '</div> <!-- end .awdMetaBox -->';
  } //end foreach
}//end function createMetaBox
 
 
function saveMetaData($post_id, $post) {
  //make sure we're saving at the right time.
  //DOING_AJAX is set when saving a quick edit on the page that displays all posts/pages  
  //Not checking for this will cause our meta data to be overwritten with blank data.
  if ( empty($_POST)
    || !wp_verify_nonce($_POST['awd_nonce_field'],'awd_nonce_action')
    || $post->post_type == 'revision'
    || defined('DOING_AJAX' )) {
    return;
  }
 
  global $metaBox;
  global $wpdb;
 
  foreach ($metaBox['fields'] as $field) {
    $value = $_POST[$field['id']];
 
    if ($field['type'] == 'media' && !is_numeric($value) ) {
      //Convert URL to Attachment ID.
      $value = $wpdb->get_var(
        "SELECT ID FROM $wpdb->posts 
         WHERE guid = '$value' 
         AND post_type='attachment' LIMIT 1");
    }
    update_post_meta($post_id, $field['id'], $value);
  }//end foreach
}//end function saveMetaData
 
/**
 * Add JavaScript to get URL from media uploader.
 */
function embedUploaderCode() {
  ?>
  <script type="text/javascript">
  jQuery(document).ready(function() {
 
    jQuery('.removeImageBtn').click(function() {
      jQuery(this).closest('p').prev('.awdMetaImage').html('');   
      jQuery(this).prev().prev().val('');
      return false;
    });
 
    jQuery('.image_upload_button').click(function() {
      inputField = jQuery(this).prev('.metaValueField');
      tb_show('', 'media-upload.php?TB_iframe=true');
      window.send_to_editor = function(html) {
        url = jQuery(html).attr('href');
        inputField.val(url);
        inputField.closest('p').prev('.awdMetaImage').html('<p>URL: '+ url + '</p>');  
        tb_remove();
      };
      return false;
    });
  });
 
  </script>
  <?php
}//end function embedUploaderCode()

?>